searchNodes=[{"doc":"ExTrade is an Elixir client library for interacting with the E*TRADE API . ExTrade manages current authorization state (e.g., request and access tokens) in a supervised process, which serves as an in-memory data store for constructing the necessary &quot;Authorization&quot; header for each API request, per the OAuth 1.0 specification that E*TRADE follows.","ref":"ExTrade.html","title":"ExTrade","type":"module"},{"doc":"Interface to the E*TRADE Accounts API .","ref":"ExTrade.Accounts.html","title":"ExTrade.Accounts","type":"module"},{"doc":"Retrieve a given ExTrade.Accounts.Account 's ExTrade.Accounts.Balance via the Get Account Balances endpoint. Optional Query Parameters :acount_type :real_time_nav","ref":"ExTrade.Accounts.html#get_account_balance/2","title":"ExTrade.Accounts.get_account_balance/2","type":"function"},{"doc":"Retrieve a list of ExTrade.Accounts.Account s via the List Accounts endpoint.","ref":"ExTrade.Accounts.html#list_accounts/0","title":"ExTrade.Accounts.list_accounts/0","type":"function"},{"doc":"Retrieve a given ExTrade.Accounts.Transaction 's ExTrade.Accounts.TransactionDetails via the List Transaction Details endpoint. Optional Query Parameters :store_id","ref":"ExTrade.Accounts.html#list_transaction_details/3","title":"ExTrade.Accounts.list_transaction_details/3","type":"function"},{"doc":"Retrieve a given ExTrade.Accounts.Account 's list of ExTrade.Accounts.Transaction s via the List Transactions endpoint. Optional Query Parameters :count :end_date :marker :sort_order :start_date","ref":"ExTrade.Accounts.html#list_transactions/2","title":"ExTrade.Accounts.list_transactions/2","type":"function"},{"doc":"Retrieve a given ExTrade.Accounts.Account 's ExTrade.Accounts.Portfolio via the View Portfolio endpoint. Optional Query Parameters :count :lots_required :market_session :sort_by :sort_order :totals_required :view","ref":"ExTrade.Accounts.html#view_portfolio/2","title":"ExTrade.Accounts.view_portfolio/2","type":"function"},{"doc":"Interface to the E*TRADE Alerts API .","ref":"ExTrade.Alerts.html","title":"ExTrade.Alerts","type":"module"},{"doc":"Retrieve a given ExTrade.Alerts.Alert 's ExTrade.Alerts.AlertDetails via the List Alert Details endpoint. Optional Query Parameters :html_tags","ref":"ExTrade.Alerts.html#get_alert_details/2","title":"ExTrade.Alerts.get_alert_details/2","type":"function"},{"doc":"Retrieve a list of ExTrade.Alerts.Alert s via the List Alerts endpoint. Optional Query Parameters :category :count :direction :search :status","ref":"ExTrade.Alerts.html#list_alerts/1","title":"ExTrade.Alerts.list_alerts/1","type":"function"},{"doc":"Interface to the E*TRADE Authorization API . More information on the OAuth workflow with E*TRADE can be found in their Developer Guides .","ref":"ExTrade.Authorization.html","title":"ExTrade.Authorization","type":"module"},{"doc":"Retrieves an access token and secret via the Get Access Token endpoint using the provided verifier code, which is then stored in memory and used to construct authorization headers for all API requests. The access token will become &quot;inactive&quot; after two hours of inactivity. Using renew_access_token/0 will reactivate the inactive access token. By default, all access tokens are &quot;expired&quot; at the end of the current calendar day, US Eastern time. Once the token has expired, no requests will be processed for that token until the OAuth process is repeated and a new access token is retrieved.","ref":"ExTrade.Authorization.html#get_access_token/1","title":"ExTrade.Authorization.get_access_token/1","type":"function"},{"doc":"Constructs an authorization header using the current access tokens stored in memory.","ref":"ExTrade.Authorization.html#get_authorization_header/2","title":"ExTrade.Authorization.get_authorization_header/2","type":"function"},{"doc":"Retrieves a request token and secret via the Get Request Token endpoint, which is then stored in memory and used to construct an authorization URL. The returned authorization URL can be followed to authenticate with E*TRADE and retrieve the verifier code necessary to invoke get_access_token/1 . The request token, and therefore the generated authorization URL, is only valid for five minutes. After that, a new one will have to be generated.","ref":"ExTrade.Authorization.html#get_authorization_url/0","title":"ExTrade.Authorization.get_authorization_url/0","type":"function"},{"doc":"Renews the current access token and secret via the Renew Access Token endpoint.","ref":"ExTrade.Authorization.html#renew_access_token/0","title":"ExTrade.Authorization.renew_access_token/0","type":"function"},{"doc":"Revokes the current access token and secret via the Revoke Access Token endpoint.","ref":"ExTrade.Authorization.html#revoke_access_token/0","title":"ExTrade.Authorization.revoke_access_token/0","type":"function"},{"doc":"A struct representing an E*TRADE Account model. Note: Keys have been re-formatted for snake_casing . In some instances, they have also been updated for clarity and consistency.","ref":"ExTrade.Accounts.Account.html","title":"ExTrade.Accounts.Account","type":"module"},{"doc":"","ref":"ExTrade.Accounts.Account.html#t:t/0","title":"ExTrade.Accounts.Account.t/0","type":"type"},{"doc":"A struct representing an E*TRADE BalanceResponse model. Note: Keys have been re-formatted for snake_casing . In some instances, they have also been updated for clarity and consistency.","ref":"ExTrade.Accounts.Balance.html","title":"ExTrade.Accounts.Balance","type":"module"},{"doc":"","ref":"ExTrade.Accounts.Balance.html#t:t/0","title":"ExTrade.Accounts.Balance.t/0","type":"type"},{"doc":"A struct representing an E*TRADE Brokerage model. Note: Keys have been re-formatted for snake_casing . In some instances, they have also been updated for clarity and consistency.","ref":"ExTrade.Accounts.Brokerage.html","title":"ExTrade.Accounts.Brokerage","type":"module"},{"doc":"","ref":"ExTrade.Accounts.Brokerage.html#t:t/0","title":"ExTrade.Accounts.Brokerage.t/0","type":"type"},{"doc":"A struct representing an E*TRADE Cash model. Note: Keys have been re-formatted for snake_casing . In some instances, they have also been updated for clarity and consistency.","ref":"ExTrade.Accounts.Cash.html","title":"ExTrade.Accounts.Cash","type":"module"},{"doc":"","ref":"ExTrade.Accounts.Cash.html#t:t/0","title":"ExTrade.Accounts.Cash.t/0","type":"type"},{"doc":"A struct representing an E*TRADE Category model. Note: Keys have been re-formatted for snake_casing . In some instances, they have also been updated for clarity and consistency.","ref":"ExTrade.Accounts.Category.html","title":"ExTrade.Accounts.Category","type":"module"},{"doc":"","ref":"ExTrade.Accounts.Category.html#t:t/0","title":"ExTrade.Accounts.Category.t/0","type":"type"},{"doc":"A struct representing an E*TRADE CompleteView model. Note: Keys have been re-formatted for snake_casing . In some instances, they have also been updated for clarity and consistency.","ref":"ExTrade.Accounts.CompleteView.html","title":"ExTrade.Accounts.CompleteView","type":"module"},{"doc":"","ref":"ExTrade.Accounts.CompleteView.html#t:t/0","title":"ExTrade.Accounts.CompleteView.t/0","type":"type"},{"doc":"A struct representing an E*TRADE ComputedBalance model. Note: Keys have been re-formatted for snake_casing . In some instances, they have also been updated for clarity and consistency.","ref":"ExTrade.Accounts.Computed.html","title":"ExTrade.Accounts.Computed","type":"module"},{"doc":"","ref":"ExTrade.Accounts.Computed.html#t:t/0","title":"ExTrade.Accounts.Computed.t/0","type":"type"},{"doc":"A struct representing an E*TRADE FundamentalView model. Note: Keys have been re-formatted for snake_casing . In some instances, they have also been updated for clarity and consistency.","ref":"ExTrade.Accounts.FundamentalView.html","title":"ExTrade.Accounts.FundamentalView","type":"module"},{"doc":"","ref":"ExTrade.Accounts.FundamentalView.html#t:t/0","title":"ExTrade.Accounts.FundamentalView.t/0","type":"type"},{"doc":"A struct representing an E*TRADE Lending model. Note: Keys have been re-formatted for snake_casing . In some instances, they have also been updated for clarity and consistency.","ref":"ExTrade.Accounts.Lending.html","title":"ExTrade.Accounts.Lending","type":"module"},{"doc":"","ref":"ExTrade.Accounts.Lending.html#t:t/0","title":"ExTrade.Accounts.Lending.t/0","type":"type"},{"doc":"A struct representing an E*TRADE Margin model. Note: Keys have been re-formatted for snake_casing . In some instances, they have also been updated for clarity and consistency.","ref":"ExTrade.Accounts.Margin.html","title":"ExTrade.Accounts.Margin","type":"module"},{"doc":"","ref":"ExTrade.Accounts.Margin.html#t:t/0","title":"ExTrade.Accounts.Margin.t/0","type":"type"},{"doc":"A struct representing an E*TRADE OpenCalls model. Note: Keys have been re-formatted for snake_casing . In some instances, they have also been updated for clarity and consistency.","ref":"ExTrade.Accounts.OpenCall.html","title":"ExTrade.Accounts.OpenCall","type":"module"},{"doc":"","ref":"ExTrade.Accounts.OpenCall.html#t:t/0","title":"ExTrade.Accounts.OpenCall.t/0","type":"type"},{"doc":"A struct representing an E*TRADE OptionsWatchView model. Note: Keys have been re-formatted for snake_casing . In some instances, they have also been updated for clarity and consistency.","ref":"ExTrade.Accounts.OptionsWatchView.html","title":"ExTrade.Accounts.OptionsWatchView","type":"module"},{"doc":"","ref":"ExTrade.Accounts.OptionsWatchView.html#t:t/0","title":"ExTrade.Accounts.OptionsWatchView.t/0","type":"type"},{"doc":"A struct representing an E*TRADE PerformanceView model. Note: Keys have been re-formatted for snake_casing . In some instances, they have also been updated for clarity and consistency.","ref":"ExTrade.Accounts.PerformanceView.html","title":"ExTrade.Accounts.PerformanceView","type":"module"},{"doc":"","ref":"ExTrade.Accounts.PerformanceView.html#t:t/0","title":"ExTrade.Accounts.PerformanceView.t/0","type":"type"},{"doc":"A struct representing an E*TRADE AccountPortfolio model. Note: Keys have been re-formatted for snake_casing . In some instances, they have also been updated for clarity and consistency.","ref":"ExTrade.Accounts.Portfolio.html","title":"ExTrade.Accounts.Portfolio","type":"module"},{"doc":"","ref":"ExTrade.Accounts.Portfolio.html#t:t/0","title":"ExTrade.Accounts.Portfolio.t/0","type":"type"},{"doc":"A struct representing an E*TRADE PortfolioMargin model. Note: Keys have been re-formatted for snake_casing . In some instances, they have also been updated for clarity and consistency.","ref":"ExTrade.Accounts.PortfolioMargin.html","title":"ExTrade.Accounts.PortfolioMargin","type":"module"},{"doc":"","ref":"ExTrade.Accounts.PortfolioMargin.html#t:t/0","title":"ExTrade.Accounts.PortfolioMargin.t/0","type":"type"},{"doc":"A struct representing an E*TRADE PortfolioResponse model. Note: Keys have been re-formatted for snake_casing . In some instances, they have also been updated for clarity and consistency.","ref":"ExTrade.Accounts.PortfolioResponse.html","title":"ExTrade.Accounts.PortfolioResponse","type":"module"},{"doc":"","ref":"ExTrade.Accounts.PortfolioResponse.html#t:t/0","title":"ExTrade.Accounts.PortfolioResponse.t/0","type":"type"},{"doc":"A struct representing an E*TRADE Position model. Note: Keys have been re-formatted for snake_casing . In some instances, they have also been updated for clarity and consistency.","ref":"ExTrade.Accounts.Position.html","title":"ExTrade.Accounts.Position","type":"module"},{"doc":"","ref":"ExTrade.Accounts.Position.html#t:t/0","title":"ExTrade.Accounts.Position.t/0","type":"type"},{"doc":"A struct representing an E*TRADE PositionLot model. Note: Keys have been re-formatted for snake_casing . In some instances, they have also been updated for clarity and consistency.","ref":"ExTrade.Accounts.PositionLot.html","title":"ExTrade.Accounts.PositionLot","type":"module"},{"doc":"","ref":"ExTrade.Accounts.PositionLot.html#t:t/0","title":"ExTrade.Accounts.PositionLot.t/0","type":"type"},{"doc":"A struct representing an E*TRADE Product model. Note: Keys have been re-formatted for snake_casing . In some instances, they have also been updated for clarity and consistency.","ref":"ExTrade.Accounts.Product.html","title":"ExTrade.Accounts.Product","type":"module"},{"doc":"","ref":"ExTrade.Accounts.Product.html#t:t/0","title":"ExTrade.Accounts.Product.t/0","type":"type"},{"doc":"A struct representing an E*TRADE ProductId model. Note: Keys have been re-formatted for snake_casing . In some instances, they have also been updated for clarity and consistency.","ref":"ExTrade.Accounts.ProductID.html","title":"ExTrade.Accounts.ProductID","type":"module"},{"doc":"","ref":"ExTrade.Accounts.ProductID.html#t:t/0","title":"ExTrade.Accounts.ProductID.t/0","type":"type"},{"doc":"A struct representing an E*TRADE QuickView model. Note: Keys have been re-formatted for snake_casing . In some instances, they have also been updated for clarity and consistency.","ref":"ExTrade.Accounts.QuickView.html","title":"ExTrade.Accounts.QuickView","type":"module"},{"doc":"","ref":"ExTrade.Accounts.QuickView.html#t:t/0","title":"ExTrade.Accounts.QuickView.t/0","type":"type"},{"doc":"A struct representing an E*TRADE RealTimeValues model. Note: Keys have been re-formatted for snake_casing . In some instances, they have also been updated for clarity and consistency.","ref":"ExTrade.Accounts.RealTimeValues.html","title":"ExTrade.Accounts.RealTimeValues","type":"module"},{"doc":"","ref":"ExTrade.Accounts.RealTimeValues.html#t:t/0","title":"ExTrade.Accounts.RealTimeValues.t/0","type":"type"},{"doc":"A struct representing an E*TRADE Totals model. Note: Keys have been re-formatted for snake_casing . In some instances, they have also been updated for clarity and consistency.","ref":"ExTrade.Accounts.Totals.html","title":"ExTrade.Accounts.Totals","type":"module"},{"doc":"","ref":"ExTrade.Accounts.Totals.html#t:t/0","title":"ExTrade.Accounts.Totals.t/0","type":"type"},{"doc":"A struct representing an E*TRADE Transaction model. Note: Keys have been re-formatted for snake_casing . In some instances, they have also been updated for clarity and consistency.","ref":"ExTrade.Accounts.Transaction.html","title":"ExTrade.Accounts.Transaction","type":"module"},{"doc":"","ref":"ExTrade.Accounts.Transaction.html#t:t/0","title":"ExTrade.Accounts.Transaction.t/0","type":"type"},{"doc":"A struct representing an E*TRADE TransactionDetailsResponse model. Note: Keys have been re-formatted for snake_casing . In some instances, they have also been updated for clarity and consistency.","ref":"ExTrade.Accounts.TransactionDetails.html","title":"ExTrade.Accounts.TransactionDetails","type":"module"},{"doc":"","ref":"ExTrade.Accounts.TransactionDetails.html#t:t/0","title":"ExTrade.Accounts.TransactionDetails.t/0","type":"type"},{"doc":"A struct representing an E*TRADE Alert model. Note: Keys have been re-formatted for snake_casing . In some instances, they have also been updated for clarity and consistency.","ref":"ExTrade.Alerts.Alert.html","title":"ExTrade.Alerts.Alert","type":"module"},{"doc":"","ref":"ExTrade.Alerts.Alert.html#t:t/0","title":"ExTrade.Alerts.Alert.t/0","type":"type"},{"doc":"A struct representing an E*TRADE AlertDetailsResponse model. Note: Keys have been re-formatted for snake_casing . In some instances, they have also been updated for clarity and consistency.","ref":"ExTrade.Alerts.AlertDetails.html","title":"ExTrade.Alerts.AlertDetails","type":"module"},{"doc":"","ref":"ExTrade.Alerts.AlertDetails.html#t:t/0","title":"ExTrade.Alerts.AlertDetails.t/0","type":"type"},{"doc":"","ref":"ExTrade.Response.html","title":"ExTrade.Response","type":"module"},{"doc":"","ref":"ExTrade.Response.html#t:error_t/0","title":"ExTrade.Response.error_t/0","type":"type"},{"doc":"","ref":"ExTrade.Response.html#t:success_t/0","title":"ExTrade.Response.success_t/0","type":"type"},{"doc":"","ref":"ExTrade.Response.html#t:t/0","title":"ExTrade.Response.t/0","type":"type"},{"doc":"A struct which represents an error that occurred during an E*TRADE API call. This struct is designed to provide all the information needed to effectively manage an error response. It contains the following fields: :body – the raw HTTP response body :status_code – the HTTP response status code (e.g., 401) :status_reason – the human-readable interpretation of the status_code (e.g., &quot;Unauthorized&quot;) :error_code – the custom error code sent by E*TRADE and parsed from body :user_reason – the custom error reason/message sent by E*TRADE and parsed from body","ref":"ExTrade.Response.Error.html","title":"ExTrade.Response.Error","type":"module"},{"doc":"","ref":"ExTrade.Response.Error.html#t:t/0","title":"ExTrade.Response.Error.t/0","type":"type"},{"doc":"WIP: Not recommended for use in any sort of production setting or with production API credentials. ExTrade is an Elixir client library for interacting with the E*TRADE API .","ref":"readme.html","title":"Overview","type":"extras"},{"doc":"Install this package by adding extrade to your list of dependencies in mix.exs . def deps do [ { :extrade , &quot;~&gt; 0.0.1&quot; } ] end You can now run mix deps.get .","ref":"readme.html#installation","title":"Overview - Installation","type":"extras"},{"doc":"Within config.exs or within the environment specific config files (e.g. dev.exs ) add your E*TRADE API credentials and the appropriate environment ( :sandbox for testing, :production for the real deal). config :extrade , api_key : &quot;&lt;API_KEY&gt;&quot; , api_secret : &quot;&lt;API_SECRET&quot; , environment : :sandbox","ref":"readme.html#configuration","title":"Overview - Configuration","type":"extras"},{"doc":"OAuth ExTrade manages current authorization state (e.g., request and access tokens) in a supervised process, which serves as an in-memory data store for constructing the necessary &quot;Authorization&quot; header for each API request, per the OAuth 1.0 specification that E*TRADE follows. The flow within ExTrade is as follows: Generate the request token and authorization URL, all done via ExTrade.Authorization.get_authorization_url/0 Follow the URL provided from the prior step and authenticate with E*TRADE, then note the verifier code presented. Pass the verifier code to ExTrade.Authorization.get_access_token/1 E.g., iex&gt; ExTrade.Authorization . get_authorization_ur ( ) { :ok , &quot;https://us.etrade.com/e/t/etws/authorize?key=abc&amp;token=def&quot; } iex&gt; ExTrade.Authorization . get_access_token ( &quot;ZYXWV&quot; ) # Retrieved from the E*TRADE Auth UI :ok At this point you are now ready to begin making API calls. Note The access token will become &quot;inactive&quot; after two hours of inactivity. Using renew_access_token/0 will reactivate the inactive access token. By default, all access tokens are &quot;expired&quot; at the end of the current calendar day, US Eastern time. Once the token has expired, no requests will be processed for that token until the OAuth process is repeated and a new access token is retrieved. API ExTrade will map each returned object and its nested objects into an internal struct. It does so with some opinions on key naming and will re-format keys for clarity and consistency. For example, the keys &quot;dividend&quot; and &quot;divYield&quot; will be cast to :dividend and :dividend_yield , respectively. Currently, only the Accounts and Alerts (sans Delete Alerts ) sections are implemented. Example iex&gt; ExTrade.Accounts . list_accounts ( ) { :ok , [ % ExTrade.Accounts.Account { account_description : &quot;Brokerage&quot; , account_id : &quot;82314598&quot; , account_id_key : &quot;dBZOKt9xDrtRSAOl4MSiiA&quot; , account_mode : &quot;IRA&quot; , account_name : &quot;NickName-1&quot; , account_status : &quot;ACTIVE&quot; , account_type : &quot;MARGIN&quot; , closed_date : nil , institution_type : &quot;BROKERAGE&quot; , is_shareworks_account : false } , % ExTrade.Accounts.Account { account_description : &quot;Complete Savings&quot; , account_id : &quot;58315636&quot; , account_id_key : &quot;vQMsebA1H5WltUfDkJP48g&quot; , ... } , ... ] }","ref":"readme.html#usage","title":"Overview - Usage","type":"extras"}]